%% test, compare with IRBLEIGS

global A
global ea 


for  ndim = 1000 : 1000: 4000
%for  ndim = 600 : 100 : 600
  A = rand(ndim);
  A=(A+A')/2;
  A(1,1)=1000;
  disp('call eig(A), it may take a while ...');
  ea = eig(A);

%  for nneed = 20 : 40:  min(ndim/4, 220)
 for nneed = 20 : 10:  30
    blksize = 5;
    blkcontrol=0;
    %blkcontrol=-1;
    orthF = 0;
    %max_restart = max(20, floor(ndim/40));
    max_restart = max(20, floor(ndim/50));

    k = nneed+1;
    m = 2*k;
 
    F = rand(ndim, blksize);
    fprintf('begin krylov-spectral: ndim = %i, nneed=%i\n\n', ndim, nneed);

    t1 = cputime;
    [eigval, V, nconv, T, info] = ks(nneed);
                                  
    t2 = cputime - t1;
    et = eig(T);
    ea_et = ea(1:nconv) - et(1:nconv); 
    ii =find(abs(ea_et) > 1e-10);  
    if (size(ii) > 0),
      for j=1:size(ii)
	fprintf('\ea(%i) - et(%i) = %e\n', ii(j), ii(j), ea_et(ii(j))),
      end
    end
    
    ea_eigval= ea(1:nconv)-eigval(1:nconv);
    ii =find(abs(ea_eigval) > 1e-10);  
    if (size(ii) > 0),
      for j=1:size(ii)
	fprintf('\ea(%i) - et(%i) = %e\n', ii(j), ii(j), ea_eigval(ii(j))),
      end
    end
    
    
    t3 = cputime - t1;
    fprintf('END krylov-spectral: nconv = %i, nneed=%i\n\n', nconv, nneed);   
    

    fprintf('begin irbleigs: ndim = %i, nneed=%i\n\n', ndim, nneed);
    OPTS = struct('BLSZ', blksize, 'K', nneed, 'SIGMA', 'SE', 'MAXIT', ndim/2);
    tBL = cputime;
    [V2,D] = irbleigs(A, OPTS);
    nd = size(D,1);
    if (nd > 0),
      d= diag(D(1:nd,1:nd))-ea(1:nd);
      max_diff = max(d)
    else
      d=[]
    end
    tb2= cputime - tBL;
    fprintf('END irbleigs: nconv = %i, nneed=%i\n\n', nd, nneed);
    
    fprintf('cputime comparison:  irbleig/kry_spec =%f, 2irbleig/kry_spec=%f \n\n', tb2/t2, tb2/t3 );

  end
end
