function [F] = selected_reorth(F, V, nrmold, T)
%   
%    
%  selected_reorth produce an F that is orthogonal to V, 
%  it applies a second step Gram-Schmidt orthogonalization
%  if that is determined to be necessary.
%   
%  
  
%
% local variables
%
  reorth=0.717;
  
%
% begin selected_reorth   
%   
  for j = 1 : size(F,2)
    
    nrmproj(j) = norm(F(:,j));
    
    if (nrmproj(j) >  reorth*nrmold(j))
      %
      % reorthogonalization not necessary
      %
    else
      %
      % 2nd step Gram-Schmidt reorthogonalization
      % if the 2nd step still does not produce a valid vector, just 
      % leave this invalid vector in the basis. the QR step following 
      % this function will detect this invalid vector and replace it 
      % by a suitable vector.
      %
      %nrmold(j) = nrmproj(j);
      h =  V'* F(:,j);
      F(:,j) = F(:,j) - V*h;
      if (nargin >3), T(:,j) = T(:,j)+h; end
      
    end
    
  end
  
  
  